#include <hmg.ch>

*------------------------------------------------------------* 
 FUNCTION  Hours_View()
*------------------------------------------------------------*
 
   set navigation extended       
   set date german               
   set date format to "dd/mm/yyyy"
   set century on                
   SET TOOLTIPSTYLE BALLOON 
 
   public aTable  := {}
   public aCurRow := {}
   public dbo     := nil
   public cDBName  , PriNc ,  mtable , aFldnm
   public Num , poner, poner1 , poner2
   public fColorx , bColorx

   IF FILE("tempo.mem")  
      FileDelete("tempo.mem")
   ENDIF

*---------------------------------------------------------------------------------------------*
   dbo := connect2db("control.db3",.F.)    // <-----------------  Desconectar Base de Control
*---------------------------------------------------------------------------------------------*

  cDBName := "datetime.db3"

  dbo := connect2db("datetime.db3",.T.) 

  Define Window sample at 0,0 width 800 height 645 ICON "" TITLE "View  SQLite -"+" &cDBName " ;
                                        MODAL NOSYSMENU CURSOR "" NOSIZE  ON INIT IniTiusP()

    ON KEY ESCAPE ACTION  eiXida()     

    DEFINE TIMER Timer_2dQ ;
              INTERVAL 100 ;
              ACTION { || thisWindow.Row := 058, thisWindow.Col := 276 }     

     @ 025,275 LABEL label1 VALUE"View  SQLite -"+SPACE(2)+ cDBName WIDTH 400 HEIGHT 20 FONT  "Arial" SIZE 13 BOLD

*-----------------------------------------------------  table  --------------------------------------------------------------*
 PUBLIC  fColor := { || if ( This.CellRowIndex/2 == int(This.CellRowIndex/2) , BLUE , RED ) }
 PUBLIC  bcolor := { || if ( This.CellRowIndex/2 = int (This.CellRowIndex/2) , {180,200,255} , {255,255,211} ) }   
*------------------------------------------------------- Color Barra Video Inversa -------------------------------------------*
  _HMG_SYSDATA [ 348 ] := { 199,250,225 }    
  _HMG_SYSDATA [ 349 ] := { 007,071,041 }   
  _HMG_SYSDATA [ 350 ] := { 235,237,095 }   
  _HMG_SYSDATA [ 351 ] := { 069,015,135 }  
*-----------------------------------------------------------------------------------------------------------------------------*

     define grid table
          row    060
          col    019
          width  756  
          height 431 
          ITEMS aGrid                             
          VALUE 1
          widths  { 080,112,162,076,074,076,074,074 } 
          headers { "Num","Name","Charge","Dia_E","Hora_E","Dia_S","Hora_S","Hora_T" }
          DYNAMICFORECOLOR  { fColor, fColor, fColor , fColor, fColor , fColor , fColor , fColor}
          DYNAMICBACKCOLOR  { bColor, bColor, bColor , bColor, bColor , bColor , bColor , bColor }  
          BACKCOLOR { 209,238,238 }
          FONTCOLOR { 000,255,020 } 
          ONCHANGE ArribAbajoXt()  
          MULTISELECT .F.
          FONTNAME 'Arial'
          FONTSIZE 9
          SHOWHEADERS .T.  
          CELLNAVIGATION .T.
          JUSTIFY { 1, 0, 0 , 2 , 2 , 2 , 2 , 2 }  
     end grid
*----------------------------------------------------------------------*

       DEFINE LABEL Lab_Sea
          ROW    521
          COL    193
          WIDTH  155
          HEIGHT 024
          VALUE "Checking Name for Print"        
          FONTNAME "Arial"
          FONTSIZE 10
          FONTBOLD .T.
          FONTITALIC .F.
      END LABEL

      DEFINE LABEL Lab_Sea2
          ROW    521
          COL    193
          WIDTH  155
          HEIGHT 024
          VALUE "Listing Hours to Print"          
          FONTNAME "Arial"
          FONTSIZE 10
          FONTBOLD .T.
          FONTITALIC .F.
      END LABEL

      DEFINE  CHECKBOX Check_1x
          ROW    517
          COL    513
          WIDTH  030 
          VALUE  .T. 
          FONTNAME "Arial"
          FONTSIZE 9
          FONTBOLD .T.  
          ONCHANGE CambiamA()
       END CHECKBOX

*----------------------------------------------------------------*

    @ 520, 032 Label Label_1Gt              ;   
                width   055                 ;
                height  027                 ;  
                FONT "Arial"  SIZE 10 BOLD  ;
                VALUE "Records:"  
     
     @ 520, 100 Label Label_2Gt             ;   
                width   094                 ;
                height  027                 ;  
                FONT "Arial"  SIZE 10 BOLD  ;
                VALUE ""  

*------------------------------------------------------------------------------------------------------------* 
*----------------------------------------------------  Up-Down  ---------------------------------------------*
*------------------------------------------------------------------------------------------------------------*    

    DEFINE BUTTON But_01xQP  
         ROW    520 
         COL    630        
         WIDTH  028 
         HEIGHT 028 
         PICTURE "Resource/btn_01.bmp"   
         TOOLTIP 'First'//'Primero'  
         ACTION  GoFirstP()                                         
     END BUTTON

     DEFINE BUTTON But_02xQP 
         ROW    520
         COL    659
         WIDTH  028  
         HEIGHT 028  
         PICTURE "Resource/btn_02.bmp"    
         TOOLTIP 'Previous'//'Anterior'  
         ACTION GoPreviousP()  
    END BUTTON
 
    DEFINE BUTTON But_03xQP
         ROW    520
         COL    689
         WIDTH  028  
         HEIGHT 028  
         PICTURE "Resource/btn_03.bmp"  
         TOOLTIP 'Next'//'Siguiente' 
         ACTION  GoNextP() 
    END BUTTON   

    DEFINE BUTTON But_04xQP
         ROW    520
         COL    719
         WIDTH  028  
         HEIGHT 028  
         PICTURE "Resource/btn_04.bmp"  
         TOOLTIP 'Last'  //'Ultimo' 
         ACTION  GoLastP() 
    END BUTTON     
*------------------------------------------------------------------------------------------------------------*
*------------------------------------------------------------------------------------------------------------*  
     
        DEFINE TEXTBOX Tex_Sea
          ROW    520
          COL    352
          WIDTH  150
          HEIGHT 023
          FONTNAME "Arial"
          FONTSIZE 9
          TOOLTIP "Serarch by Name"
          FONTBOLD .F.
          FONTITALIC .F.        
          BACKCOLOR { 180,200,255 }      
          MAXLENGTH 20                 
          VALUE ""
          LOWERCASE .T.  
          UPPERCASE .F.   
        END TEXTBOX  

        DEFINE TEXTBOX Tex_Sea2
          ROW    520
          COL    352
          WIDTH  150
          HEIGHT 023
          FONTNAME "Arial"
          FONTSIZE 9
          TOOLTIP "Serarch by Name"
          FONTBOLD .F.
          FONTITALIC .F. 
          READONLY .T.
          DISABLEDBACKCOLOR  { 180,200,255 }       
          MAXLENGTH 20                 
          VALUE ""
          LOWERCASE .T.  
          UPPERCASE .F.   
       END TEXTBOX  

*--------------------------------------------------------------------*

       DEFINE BUTTON P_Vacuu 
          row 560  
          col 110   
          width 130
          height 40
          caption SPACE(2)-"Vacuum"
          action DeleteTotalY()         
          FONTNAME "ARIAL" 
          FONTSIZE 10 
          FONTBOLD .T.
          FONTITALIC .T. 
          PICTURE "Resource\Vacuum1.bmp"     
          PICTALIGNMENT LEFT
       END BUTTON 

       DEFINE BUTTON P_Delet 
          row 560 
          col 255  
          width 130
          height 40
          caption SPACE(2)-"Delete"
          action  DeleteRow()     
          FONTNAME "ARIAL" 
          FONTSIZE 10 
          FONTBOLD .T.
          FONTITALIC .T. 
          PICTURE "Resource\NAcep.bmp"
          PICTALIGNMENT LEFT
       END BUTTON

       DEFINE BUTTON  P_Prin
          row   560  
          col   400 
          width 130
          height 40
          caption SPACE(5)-"Print"
          action ( Preparaty() ,Report_4() )  
          FONTNAME "ARIAL" 
          FONTSIZE 10 
          FONTBOLD .T.
          FONTITALIC .T. 
          PICTURE "Resource\Print.bmp"
          PICTALIGNMENT LEFT
       END BUTTON

       DEFINE BUTTON  P_Exit
          row   560  
          col   625 
          width 130
          height 40
          caption SPACE(5)-"Exit"
          action  eiXida()     
          FONTNAME "ARIAL" 
          FONTSIZE 10 
          FONTBOLD .T.
          FONTITALIC .T. 
          PICTURE "Resource\Exit.bmp"
          PICTALIGNMENT LEFT
     END BUTTON

     Chane_StylexP()

  end window
    
     SETWINDOWCURSOR ( sample.P_Exit.Handle, "Resource\SmoothHand.cur")

     RefreshTableP()

    sample.Check_1x.Value := .F.
    sample.Lab_Sea2.Hide 
    sample.Tex_Sea2.Hide 
    sample.Tex_Sea.SetFocus

  sample.center
  sample.activate

Return NIL


*---------------------------------------------------------*
 Function Preparaty()  // Preparando para Imprimir Nombre Selectivo
*---------------------------------------------------------*

 mirux1 :=  alltrim( sample.Tex_Sea.Value)
 
 FileDelete("tempo.mem") 
 
 IF  mirux1 > SPACE(1)
     SAVE all like  mirux1* to tempo  
     sample.Tex_Sea.Value := ""
 ELSE
     FileDelete("tempo.mem")
 ENDIF

 Return NIL

*---------------------------------------------------------*
 Function  eiXida()   
*---------------------------------------------------------*
 
*------------------------------------------*
  dbo := connect2db("control.db3" ,.T.)      // <-----------------  Desconectar Base de Control
  dbo := connect2db("datetime.db3",.F.)      // <-----------------  Desconectar Base de Control
* dbo := connect2db("nombre.db3"  ,NIL)     //  <-----------------  Conectar Base de Clientes
*------------------------------------------*

  sample.Release 

Return NIL

*---------------------------------------------------------*
 Function IniTiusP()
*---------------------------------------------------------*
 LOCAL aValue := sample.table.Value

 sample.Check_1x.Value := .F.
 sample.Lab_Sea2.Hide 
 sample.Tex_Sea2.Hide 

 sample.table.SetFocus
 sample.table.Value := { 1, sample.table.Value[2] }
 ArribAbajoXt()   

 Return

*---------------------------------------------------------*
 Function GoFirstP()
*---------------------------------------------------------*
 LOCAL aValue := sample.table.Value

 sample.table.SetFocus
 sample.table.Value := { 1, sample.table.Value[2] }
 ArribAbajoXt()   

 Return

*---------------------------------------------------------*
 Function GoPreviousP()
*---------------------------------------------------------*
  LOCAL aValue := sample.table.Value

  sample.table.SetFocus

  IF aValue[1] > 1
    sample.table.Value := { aValue[1] - 1, aValue[2] }
    ArribAbajoXt()   
  ENDIF

 Return

*---------------------------------------------------------*
 Function GoNextP()
*---------------------------------------------------------*
  LOCAL aValue := sample.table.Value

  sample.table.SetFocus

  IF aValue[1] < sample.table.Itemcount
    sample.table.Value := { aValue[1] + 1, aValue[2] }
   ArribAbajoXt()   
  ENDIF

 Return

*---------------------------------------------------------*
 Function GoLastP()
*---------------------------------------------------------*
 LOCAL aValue := sample.table.Value

 sample.table.SetFocus
 sample.table.Value := { sample.table.Itemcount, sample.table.Value[2] }
 ArribAbajoXt()   

 Return

*--------------------------------------- -----------------*
FUNCTION ArribAbajoXt()      // Cuenta Registros
*---------------------------------------------------------*
  PRIVATE aliney :={}
  PRIVATE aReturny_Sql
  PRIVATE aDataRecordy
  PRIVATE nToRecordy
  PRIVATE ncQuery_
  PRIVATE numerRty 


  dbo := connect2db("datetime.db3" ,.T.)  
 
  nToRecordy := 0

  ncQuery_ := "SELECT  ID, NAME,CHARGE,DIA_E ,HORA_E,DIA_S ,HORA_S ,HORA_T FROM datetime ORDER BY ID" 

  aReturny_Sql := Sqlite_Cmd( dbo, ncQuery_  )

  FOR EACH  aDataRecordy IN aReturny_Sql
      ID := aDataRecordy[ 1 ]
              nToRecordy ++
  NEXT  aDataRecordy

  numeRty :=  nToRecordy ++
  
  aliney := sample.table.item( sample.table.Value[1] )

   sample.Label_2Gt.Value :=   ALLTRIM( STR(sample.table.Value[ 1 ] )) + " / " + ALLTRIM( STR(sample.table.ItemCount )) 
 * sample.Label_2Gt.Value :=   ALLTRIM( aliney[1] ) +space(1)+"/"+space(1)+ ALLTRIM(STR(( numeRt )))                 //  Marcador Records Opcional ?

   sample.Tex_Sea.value :=  LOWER(aliney[2])

Return Nil 

*---------------------------------------------------------*
  FUNCTION  CambiamA()
*---------------------------------------------------------*
  LOCAL aCheKQ

   aCheKQ  := ( IIF(sample.Check_1x.Value,"True","False") )
 
   IF aCheKQ = "True"   
      sample.Check_1x.TOOLTIP := 'Listing Hours to Print'     
      sample.Tex_Sea.Value    := ""
      sample.Tex_Sea.ReadOnly := .T.
      sample.Lab_Sea.Hide  
      sample.Tex_Sea.Hide
      sample.Tex_Sea2.ReadOnly := .T.
      sample.Lab_Sea2.Show   
      sample.Tex_Sea2.Show

   IF FILE("tempo.mem")
        FileDelete("tempo.mem")    
   ENDIF

   ELSE
      sample.Check_1x.TOOLTIP := 'Checking Name for Print' 
      sample.Tex_Sea.ReadOnly := .F.
      sample.Lab_Sea.Show  
      sample.Tex_Sea.Show  
      sample.Tex_Sea2.ReadOnly := .T.
      sample.Lab_Sea2.Hide   
      sample.Tex_Sea2.Hide 

    IF FILE("tempo.mem")
        FileDelete("tempo.mem")    
    ENDIF   

  ENDIF

RETURN NIL

*---------------------------------------------------------* 
 FUNCTION Chane_StylexP()
*---------------------------------------------------------* 

 HMG_ChangeWindowStyle ( GetControlHandle( "table","Sample"), LVS_REPORT, NIL, .T. )

 Return Nil

*---------------------------------------------------------* 
 FUNCTION RefreshTableP()
*---------------------------------------------------------* 

   poner   = "aCurRow[1],aCurRow[2],aCurRow[3],aCurRow[4],aCurRow[5] ,aCurRow[6],aCurRow[7],aCurRow[8]"

       sample.table.DeleteAllItems()

       aTable := SQL(dbo,"SELECT * FROM datetime ORDER BY ID ")   

       for i := 1 to len(aTable) 
             aCurRow := aTable[i]
             sample.table.additem({ &poner })
       next i
       if sample.table.itemcount > 0
             sample.table.value := 1 
       endif
              sample.table.Refresh
 Return Nil

*---------------------------------------------------------*
 FUNCTION DeleteTotalY()
*---------------------------------------------------------*

Local oQueryA
Local aGridRowA
Local iA
Local cROWIDA 
Local nLineNoA := 0

        dbo := connect2db("datetime.db3",.T.) 
	iA := sample.table.Value[1] 
        nLineNoA  := sample.table.Value[1] 
	
   oQueryA:= miscsql(dbo,"begin immediate")  // others can continue to read but no new readers

  if oQueryA = .T.   //  db is not locked   

        if MsgYesNo("Eraser Database ?","datetime.db3")
               aGridRowA	:= sample.table.Item (iA)
	       cROWIDA		:= aGridRowA [1] 
   
          oQueryA := miscsql(dbo,"DELETE FROM datetime" ) 

          miscsql(dbo,"commit")  	
          sample.table.DeleteAllItems()
          sqlite3_exec(dbo,"VACUUM") 
          IniTiusP()
     else
        miscsql(dbo,"commit")   //unlock row
	   endif    
  EndIf  

Return Nil 


*---------------------------------------------------------*
Procedure DeleteRow()
*---------------------------------------------------------*
Local oQuery
Local aGridRow
Local i
Local cROWID 
Local nLineNo := 0

   Fechax  := DTOS(DATE())
   cDatux := RIGHT( alltrim(Fechax),2)+"/"+SUBSTR(alltrim(Fechax),5,2 ) +"/"+LEFT( alltrim(Fechax),4)   // Fecha Correcta

        dbo := connect2db("datetime.db3",.T.) 
	i := sample.table.Value[1] 
        nLineNo  := sample.table.Value[1] 
	
  oQuery:= miscsql(dbo,"begin immediate")  // others can continue to read but no new readers

  if oQuery = .T.   //  db is not locked   

  aGridRow	:= sample.table.Item (i)

        If MsgYesNo( "Proceed to remove the Record ?"             +CRLF  + CRLF+;   //Confirma la eliminacin del registro?   
                    "Num           :  "  +          aGridRow [1]  + CRLF + ;    
                    "UserName  :  "  +              aGridRow [2]  + CRLF + ;           
                    "Charge       :"+SPACE(2)+      aGridRow [3] ,"Delete Records" )

	                          cROWID	 := aGridRow [1]    
               oQuery := miscsql(dbo, "DELETE FROM datetime  WHERE ID == " + c2sql(cROWID))

        miscsql(dbo,"commit")   //unlock row  	

          sample.table.Deleteitem(nLineNo)

     else
        miscsql(dbo,"commit")   //unlock row
	   endif    
  EndIf  

Return  Nil 

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*








